#ifndef __TPRGLINE__
#define __TPRGLINE__

#include "defines.h"
#include "TObjArray.h"

enum FLAG { kDONTKNOW, kCOMMENT, kPRECOMP, kCOMMAND, kSYMBOL};

class TPrgLine: public TObject
{
  private:
	 TList       mExpand;
	 TString     mCodeRaw;
   TString     mCode;
	 TString     mLabel;
   TString     mComment;
	 int         mId;
	 int         mLine;
	 unsigned int    mComp;
	 bool        mIsExpanded;
	 
	 TObjArray*  mTokens;
	 TPrgLine*   mParent;
	 
	 void        cutSpaces(TString&);
	 void        cutTrash(TString&);
	 void        preStage();
	 void        expand();
	 void        addExpanded(char*);
	   
  public:
               TPrgLine(char*);
    virtual    ~TPrgLine(); 
		void       print(bool expand = false);
				
		void       setParent(TPrgLine* p) { mParent = p;}
		void       setLineNumber(int l) { mLine = l;}
		void       setLabel(char* label) { mLabel = label;}
		void       setCompiledCode(unsigned int a) {mComp = a;}
				
		bool       isExpanded() { return mIsExpanded;}
		
		char*      getCodeRaw() { return (char*)mCodeRaw.Data();}
		char*      getCode() { return (char*)mCode.Data();}
		char*      getLabel() { return (char*)mLabel.Data();}
		char*      getComment() { return (char*)mComment.Data();}
		int        getId() { return mId;}
		int        getLineNumber() { return mLine;}
		unsigned int   getCompiledCode() { return mComp;}
		int        getNTokens(); 
		char*      getToken(int);
		int        getNExpanded() { return mExpand.GetEntries();}
		TPrgLine*  getExpanded(int i) { return (TPrgLine*)mExpand.At(i);}		
		TPrgLine*  getParent() { return mParent;}
		
};
#endif
